<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_hotelRatePlanCancellationPolicyRule
 * ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_hotelRatePlanCancellationPolicyRule extends AbstractStructArrayBase
{
    /**
     * The Rule
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_hotelRatePlanCancellationPolicyRule[]
     */
    public $Rule;
    /**
     * Constructor method for ArrayOfJPSOAP_hotelRatePlanCancellationPolicyRule
     * @uses ArrayOfJPSOAP_hotelRatePlanCancellationPolicyRule::setRule()
     * @param \StructType\JPSOAP_hotelRatePlanCancellationPolicyRule[] $rule
     */
    public function __construct(array $rule = array())
    {
        $this
            ->setRule($rule);
    }
    /**
     * Get Rule value
     * @return \StructType\JPSOAP_hotelRatePlanCancellationPolicyRule[]|null
     */
    public function getRule()
    {
        return $this->Rule;
    }
    /**
     * This method is responsible for validating the values passed to the setRule method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRule method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRuleForArrayConstraintsFromSetRule(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_hotelRatePlanCancellationPolicyRuleRuleItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_hotelRatePlanCancellationPolicyRuleRuleItem instanceof \StructType\JPSOAP_hotelRatePlanCancellationPolicyRule) {
                $invalidValues[] = is_object($arrayOfJPSOAP_hotelRatePlanCancellationPolicyRuleRuleItem) ? get_class($arrayOfJPSOAP_hotelRatePlanCancellationPolicyRuleRuleItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_hotelRatePlanCancellationPolicyRuleRuleItem), var_export($arrayOfJPSOAP_hotelRatePlanCancellationPolicyRuleRuleItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Rule property can only contain items of type \StructType\JPSOAP_hotelRatePlanCancellationPolicyRule, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Rule value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_hotelRatePlanCancellationPolicyRule[] $rule
     * @return \ArrayType\ArrayOfJPSOAP_hotelRatePlanCancellationPolicyRule
     */
    public function setRule(array $rule = array())
    {
        // validation for constraint: array
        if ('' !== ($ruleArrayErrorMessage = self::validateRuleForArrayConstraintsFromSetRule($rule))) {
            throw new \InvalidArgumentException($ruleArrayErrorMessage, __LINE__);
        }
        $this->Rule = $rule;
        return $this;
    }
    /**
     * Add item to Rule value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_hotelRatePlanCancellationPolicyRule $item
     * @return \ArrayType\ArrayOfJPSOAP_hotelRatePlanCancellationPolicyRule
     */
    public function addToRule(\StructType\JPSOAP_hotelRatePlanCancellationPolicyRule $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_hotelRatePlanCancellationPolicyRule) {
            throw new \InvalidArgumentException(sprintf('The Rule property can only contain items of type \StructType\JPSOAP_hotelRatePlanCancellationPolicyRule, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Rule[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_hotelRatePlanCancellationPolicyRule|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_hotelRatePlanCancellationPolicyRule|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_hotelRatePlanCancellationPolicyRule|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_hotelRatePlanCancellationPolicyRule|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_hotelRatePlanCancellationPolicyRule|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Rule
     */
    public function getAttributeName()
    {
        return 'Rule';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_hotelRatePlanCancellationPolicyRule
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
